
#ifndef USBIO_H

/* 
 * Argyll Color Correction System
 *
 * General USB I/O support
 *
 * Author: Graeme W. Gill
 * Date:   2006/22/4
 *
 * Copyright 2006 Graeme W. Gill
 * All rights reserved.
 *
 * This material is licenced under the GNU GENERAL PUBLIC LICENCE :-
 * see the Licence.txt file for licencing details.
 */

/* These routines supliement the class code in ntio.c and unixio.c */
/* They do benign things if ENABLE_USB is undefined */

/* Add paths to USB connected instruments, to the existing */
/* icompath paths in the icoms structure. */
void usb_get_paths(
struct _icoms *p 
);

/* Return the instrument type if the port number is USB, */
/* and instUnknown if it is not. */
instType usb_is_usb_portno(icoms *p, int port);


/* Open a USB port */
void usb_open_port(
icoms *p,
int port,		/* com port, 1 - n, 0 for no change. */
int config,		/* Configuration */
int iface,		/* Interface */
int wr_ep,		/* Write end point */
int rd_ep,		/* Read end point */
int rd_qa		/* Read quanta size */
);

/* Close an open USB port */
void usb_close_port(icoms *p);


/* Our versions of usblib read/write, that check if a signal was caught */
int icoms_usb_interrupt_write(usb_dev_handle *dev, int ep, char *bytes, int size, int timeout);
int icoms_usb_interrupt_read(usb_dev_handle *dev, int ep, char *bytes, int size, int timeout);

#define USBIO_H
#endif /* USBIO_H */
